/**
 * @author l.lin
 * @created 17/07/14 17:04
 */
(function () {
    'use strict';
    angular.module('datatablesSampleApp').controller('angularWayChangeDataCtrl', function ($scope, $resource, DTOptionsBuilder, DTColumnDefBuilder) {
        var _buildPerson2Add = function (id) {
            return {
                id: id,
                firstName: 'Foo' + id,
                lastName: 'Bar' + id
            }
        };

        $scope.persons = $resource('data1.json').query();
        $scope.dtOptions = DTOptionsBuilder.newOptions().withPaginationType('full_numbers');
        $scope.dtColumnDefs = [
            DTColumnDefBuilder.newColumnDef(0),
            DTColumnDefBuilder.newColumnDef(1),
            DTColumnDefBuilder.newColumnDef(2),
            DTColumnDefBuilder.newColumnDef(3).notSortable()
        ];

        $scope.person2Add = _buildPerson2Add(1);
        $scope.addPerson = function () {
            $scope.persons.push(angular.copy($scope.person2Add));
            $scope.person2Add = _buildPerson2Add($scope.person2Add.id + 1);
        };
        $scope.editPerson = function ($index) {
            console.log('editPerson');
            // BEWARE: $scope.persons[$index] = $scope.person2Add; does not work!
            $scope.persons[$index].id = $scope.person2Add.id;
            $scope.persons[$index].firstName = $scope.person2Add.firstName;
            $scope.persons[$index].lastName = $scope.person2Add.lastName;
        };
        $scope.removePerson = function ($index) {
            console.log('removePerson');
            $scope.persons.splice($index, 1);
        };
    });
})();
